
var slidesFirstBundle = [];

function addSlides() {
	var slides = initial_data;
	var firstBundleType;
	if ( slides.length>0 ) firstBundleType = slides[0].mazzo;
	var i;
	
	slidesFirstBundle = [];
	for (i=0; i<slides.length; i++) {
		if (slides[i].mazzo == firstBundleType) {
			slidesFirstBundle.push(slides[i]);
		}		
	}
		
	var cover_data = 
	{
		"front" : {
			"type" : "text",
			"content" : ( slides.length>0 ) ? slides[0].consegnaMazzo : "",
		"extra" : ""
		},
		"back" : {
			"type" : "text",
			//"content" : ( slides.length>0 ) ? slides[0].mazzo : "",
			"content" : ( slides.length>0 ) ? ( (slides[0].consegnaMazzo == slides[0].mazzo ) ? "" :  slides[0].mazzo )  : "",
		"extra" : ""
		}
	};
	addSlide(cover_data, 0);
	slidesCounter++;
	
	if (config_data.randomCard) shuffle(slidesFirstBundle);
	var idx = 0;
	for (i=0; i<slidesFirstBundle.length; i++) {
			idx++;
			addSlide(slidesFirstBundle[i], idx);
			slidesCounter++;				
	}
	$('#bottomNumbers').text("1 di " + slidesCounter );
	
	var percentage = 100 * ( (1) /slidesCounter ) + "%";
	$( "#progressBar" ).css( "width", percentage );
}

function addSlide(slide, idx) {
	var itemBig = "";
	if (idx == 0) itemBig +="<div class=\"carousel-item active\">";
	else itemBig +="<div class=\"carousel-item\">";
           if (idx == 0) itemBig +="<div class=\"row\">";
		   else itemBig +="<div class=\"row flippable\">";
                itemBig +="<div class=\"col-12\">";
                  itemBig +="<div class=\"flip\">";
                    itemBig +="<div class=\"rolloverOff\">";
                      itemBig +="<figure class=\"cube\">";
                        if (idx == 0) itemBig +="<div class=\"d-flex flex-column box-question justify-content-center shadow-azure bg-gradient-azure front\">";
                        else itemBig +="<div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-white front\">";
				  
						  if (idx == 0) itemBig += addCover(slide);
						  else 	itemBig += addSingleSlide(slide.front, true) ;
						  		           
                       itemBig +=" </div>";
                       itemBig +=" <div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-gradient-green text-center back\">";
                        
						if (idx != 0)	 itemBig += addSingleSlide(slide.back, false) ;
						
						                 
                    itemBig +="    </div>";
                    itemBig +="  </figure>";
                  itemBig +="  </div>";
             itemBig +="     </div>";
           itemBig +="     </div>";
          itemBig +="    </div>";
        itemBig +="    </div>";
	
	$( "#carousel-big" ).append(itemBig);
	
	var itemSmall = "";
	if (idx == 0) itemSmall +="<div class=\"carousel-item active\">";
	else itemSmall +="<div class=\"carousel-item\">";
         if (idx == 0) itemSmall +=" <div class=\"flip\">";
		 else itemSmall +=" <div class=\"flip flippable\">";
              itemSmall +="  <div class=\"rolloverOff\">";
               itemSmall +="   <figure class=\"cube\">";
               if (idx == 0) itemSmall +="     <div class=\"d-flex flex-column box-question justify-content-center shadow-azure bg-gradient-azure front\">";
			   	else  itemSmall +="     <div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-white front\">";
				
					if (idx == 0) itemSmall += addCover(slide);	
                    else itemSmall += addSingleSlide(slide.front, true) ;
					                
                  itemSmall +="  </div>";
                  itemSmall +="  <div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-gradient-green back\">";
               
				 if (idx != 0)	itemSmall += addSingleSlide(slide.back, false) ;
				 
                    
                  itemSmall +="  </div>";
               itemSmall +="   </figure>";
              itemSmall +="  </div>";
             itemSmall +=" </div>";
        itemSmall +="    </div>";
		
	$( "#carousel-small" ).append(itemSmall);
	
	
	var itemDouble = ""; // parte sempre senza active
	if (idx == 0) itemDouble +="<div id=\"doubleC\" " + idx + " class=\"carousel-item active\">";
	else itemDouble +="<div id=\"doubleC\" " + idx + " class=\"carousel-item\">";
           itemDouble +=" <div class=\"row flippable\">";
             itemDouble +=" <div class=\"col-md-6\">";
               itemDouble +=" <div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-white\">";
			    
			   	itemDouble += addSingleSlide(slide.front, true) ;
				               
              itemDouble +="  </div>";
             itemDouble +=" </div>";
			 
			if (idx != 0)	{
             itemDouble +=" <div class=\"col-md-6\">";
               itemDouble +=" <div class=\"d-flex flex-column box-question justify-content-center shadow-black bg-gradient-green\">";
				 
				 itemDouble += addSingleSlide(slide.back, false) ;
				                 
              itemDouble +="  </div>";
               itemDouble +=" <img class=\"icon-expand\" src=\"img/icon-reduce.png\" alt=\"icona riduci\"/>";
             itemDouble +=" </div>";
			}
          itemDouble +="  </div>";
         itemDouble +=" </div>";
	
	$( "#carousel-double" ).append( itemDouble );
}


function addSingleSlide(slide, isFront) {
	var toRet = "";
	//toRet +="  <p class=\"text-center\">";
	
	if (slide.type == "audio") toRet += addAudioBlock(slide, isFront);
	else if (slide.type == "text") toRet += addTextBlock(slide, isFront);
	else if (slide.type == "image") toRet += addImageBlock(slide, isFront);
	else if (slide.type == "video") toRet += addVideoBlock(slide, isFront);
	
	//toRet +=" </p>";   
	return toRet;
}


function addAudioBlock(slide, isFront) {
	var toRet = "";
	toRet +="<audio controls class=\"audio-player\">";
	toRet +="<source class=\"mmp3\" src=\"" + slide.content + ".mp3\" type=\"audio/mpeg\">";
	toRet +="<source src=\"" + slide.content + ".ogg\" type=\"audio/ogg\">";
	toRet +="Il tuo browser non supporta l'elemento audio.";
	toRet +="</audio>";	
	toRet += addExtraText(slide, isFront);
	return toRet;
}


function addTextBlock(slide, isFront) {	
	var toRet = "";
	if (isFront) toRet += "<p class=\"text-center type-text back-text\" style=\"bottom-top: 50px \">" + slide.content + "</p>";
	else {
		 toRet +="<div class=\"check text-center\" alt=\"icona check verde\"></div>";
		 toRet += "<p class=\"text-center type-text front-text\">" + slide.content + "</p>";
	}
	toRet += addExtraText(slide, isFront);	
	return toRet;
}

function addImageBlock_WIP(slide, isFront) {	
	$(".box-img").css('background-image','url(' + slide.content + ')');
	var toRet = "<div id=\"boxImg1\" class=\"box-img\"></div>";
	if (slide.extra != "") toRet += "<p id=\"textCenter1\" class=\"text-center\">" + slide.extra + "</p>";
	/*
	console.info("h box img = " + $("#boxImg1").height() );
	console.info("h textCenter1 = " + $("#textCenter1").height() );
	$("#cardParent").height(2100);
	*/
	
	return toRet;
}


function addImageBlock(slide, isFront) {
	
	var toRet;
		
	if (slide.extra != "") {
		
		toRet = "<div class=\"box-img\" style=\"background-image: url("+slide.content+") \"></div>";
		toRet += "<div class=\"box-text\">";
		if (slide.extra != "") {
			if (isFront) toRet += "<p class=\"text-center back-text\">" + slide.extra + "</p>";
			else  toRet += "<p class=\"text-center front-text\">" + slide.extra + "</p>";
		}
		toRet += "</div>";
		
	}
	else {
		toRet = "<div class=\"box-img\" style=\"flex: 0 0 100%; border-radius: 6px 6px 6px 6px; background-image: url("+slide.content+") \"></div>";
	}
	
	
	
	return toRet;
}


function addVideoBlock(slide, isFront) {	
	var toRet = "";
	
	toRet +="<video controls class=\"video-player\">";
	toRet +="<source src=\"" + slide.content + ".mp4\" type=\"video/mp4\">";
	toRet +="<source src=\"" + slide.content + ".ogg\" type=\"video/ogg\">";
	toRet +="Il tuo browser non supporta l'elemento video.";
	toRet +="</video>";
	toRet += addExtraText(slide, isFront);	
	return toRet;
}

function addCover(slide) {
	var toRet = "";
    var slides = initial_data;
    if ( ( slides.length>0 ) && ( (slides[0].consegnaMazzo == slides[0].mazzo ) ) ) { // solo una riga
       toRet += "<h2 class=\"text-left cover-title\">" + (slide.front.content) + "</h2>";       
	   //toRet += "<div style=\"margin:10px 40px 20px 40px; background-color: white; height: 2px; width:30%; border-radius:1px; \"></div>";
	   toRet += "<p class=\"text-left cover-subtitle\">" + slide.back.content + "</p>";
    } else { // due righe
       toRet += "<p class=\"text-left cover-subtitle\">" + (slide.front.content) + "</p>";
	   toRet += "<div style=\"margin:0 40px 20px 40px; background-color: white; height: 2px; width:30%; border-radius:1px; \"></div>";
	   toRet += "<h2 class=\"text-left cover-title\">" + slide.back.content + "</h2>";
    }
	
	
	return toRet;
}

function addExtraText(slide, isFront) {
	var toRet = "";
	//return toRet;
	if (slide.extra != "") {
		if (isFront) toRet += "<p class=\"text-center back-text\">" + slide.extra + "</p>";
		else  toRet += "<p class=\"text-center front-text\">" + slide.extra + "</p>";
	}
	return toRet;
}