var timerCurrentValue;

if (config_data.timer == false) $( ".btn-timer" ).remove();

$( ".btn-timer" ).click(function() {
	
	if (timerState == "running") {
		pauseTimer();		
	} else if (timerState == "stopped") {
		startTimer();
	} else if (timerState == "paused") {
		startTimer();
	}
		
});


function pauseTimer() {
	clearInterval(timerCalculator);
	$( ".btn-timer" ).removeClass("bg-gradient-red").addClass( "bg-gradient-green");
	timerState = "paused";
	$( ".timer-value" ).text( "START" );
	$('.icon-timer').attr("src","img/icon-timer.png");
}

function stopTimer() {
	clearInterval(timerCalculator);
	$( ".btn-timer" ).removeClass("bg-gradient-red").addClass( "bg-gradient-green");
	timerState = "stopped";
	$( ".timer-value" ).text( "START" );
	$('.icon-timer').attr("src","img/icon-timer.png");
}

function startTimer() {
	
	$( ".btn-timer" ).removeClass( "bg-gradient-green" ).addClass( "bg-gradient-red" );
	
	if (timerState != "paused") {
		if (isFrontSide) timerCurrentValue = config_data.frontTime;
		else timerCurrentValue = config_data.backTime;
	}
		
	if (timerCurrentValue <= 0) timerCurrentValue = 0;
	
	$( ".timer-value" ).text( formatTimerValue(timerCurrentValue) );
	timerState = "running";
	$('.icon-timer').attr("src","img/icon-timer-stop.png");
	
	
	if (timerCurrentValue <= 0) return;
	
	timerCalculator = setInterval(function(){
	  timerCurrentValue--;	  
	  $( ".timer-value" ).text( formatTimerValue(timerCurrentValue) );
	  if(timerCurrentValue <= 0)
	 	 handleEndTime();
	},1000);
	
}

var wasFrontAndTimeEnded = false;
function handleEndTime() {
	clearInterval(timerCalculator);
	if (isFrontSide) {
		if (config_data.flipEndTime) {
			wasFrontAndTimeEnded = true;
			$(".flippable").flip(true); // mostro il dietro della slide
		}
		//setTimeout(startTimer, 600);
		//startTimer();
	} else {
		
		 // $('.carousel').carousel('next'); // vado alla slide successiva - ORIGINALE
				
		if (doubleViewIsActive) {
			if($('#block1').css('display') == 'none'){ 
				$('#mobileCarousel').carousel('next');
			} else {
				$('#doubleColCarousel').carousel('next');
			}
		} else {
			if($('#block2').css('display') == 'none'){ 
				$('#mobileCarousel').carousel('next');
			} else {
				$('#oneColCarousel').carousel('next');
			}
		}
		
		isFrontSide = !isFrontSide;
		
	}
}


function formatTimerValue(timerValueSeconds) {
	var toRet ="";
	if (timerValueSeconds > 59) {
		var minutes = parseInt( timerValueSeconds / 60 );
		var sec = parseInt( timerValueSeconds % 60 );
		if (sec < 10) toRet = minutes + ":" + "0" + sec;
		else  toRet = minutes + ":" + sec;
	} else {		
		if (timerValueSeconds < 10) toRet = "0" + timerValueSeconds;
		else  toRet = timerValueSeconds;
	}
	toRet += ":00";
	return toRet;
}